/**************************************************************************
** Copyright (c) 1996 Novell, Inc.  All Rights Reserved.
**
** THIS WORK IS SUBJECT TO U.S. AND INTERNATIONAL COPYRIGHT LAWS AND
** TREATIES.  USE AND REDISTRIBUTION OF THIS WORK IS SUBJECT TO THE
** LICENSE AGREEMENT ACCOMPANYING THE SOFTWARE DEVELOPMENT KIT (SDK)
** THAT CONTAINS THIS WORK.
** 
** Pursuant to the SDK License Agreement, Novell hereby grants to
** Developer a royalty-free, non-exclusive license to include the
** sample code SAPGENCB.C and derivative binaries in its product.
** Novell grants to Developer worldwide distribution rights to market,
** distribute or sell the sample code SAPGENCB.C and derivative
** binaries as a component of Developer's product(s).  Novell shall
** have no obligations to Developer or Developer's customers with
** respect to this code.
** 
** DISCLAIMER:
** 
** 	Novell, Inc. makes no representations or warranties with respect
** to the contents or use of this code, and specifically disclaims any
** express or implied warranties of merchantability or fitness for any
** particular purpose.  Further, Novell, Inc. reserves the right to revise
** this publication and to make changes to its content, at any time,
** without obligation to notify any person or entity of such revisions or
** changes.
**
** 	Further, Novell, Inc. makes no representations or warranties with
** respect to any software, and specifically disclaims any express or
** implied warranties of merchantability or fitness for any particular
** purpose.  Further, Novell, Inc. reserves the right to make changes to
** any and all parts of the software, at any time, without obligation to
** notify any person or entity of such changes.
**
***************************************************************************
**  File:   MISC.C
**
**  Desc:   Support routines for the DAI sample
**
**  Programmers:
**
**      Ini Who                     Firm
**      -----------------------------------------------------------------------
**      JB  Jan Beulich	            Novell Developer Support.
**
**  History:
**
**      When        Who What
**      -----------------------------------------------------------------------
**      10Jun96     jb  First code.
*/

#include <stdio.h>
#include <string.h>
#include <conio.h>

#include "common.h"

void convertString(char*s) {
	unsigned i,l;

	for(i = 0, l = s[0]; i < l; i++)
		s[i] = s[i+1];
	s[i] = 0;
}

void display(char*str, unsigned number, unsigned max, unsigned *curLine) {
	unsigned l, n;
	static char msgPressAnyKey[] = "Press any key to continue";

	if(++*curLine % 25 == 0) {
		printf(msgPressAnyKey);
		getch();
		printf("\r%*s\r", strlen(msgPressAnyKey), "");
	}

	for(n = 0; max; n++)
		max /= 10;

	if(n == 0) {
		l = strlen(str);
		if(l > 79) str[79] = 0;
		printf("%s\n", str);
	}
	else {
		l = strlen(str);
		if(l > 78-n) str[78-n] = 0;
		if(number)
			printf("%*lu %s\n", n, number, str);
		else
			printf("%*s %s\n", n, "", str);
	}
}

void pressAnyKeyToQuit() {
	printf("\nPress any key to quit");
	getch();
}

void showFlags(unsigned long flags, const FLAG2STRING*table, unsigned count, unsigned*pLine) {
	unsigned i;
	char s[128];

	s[0] = 0;
	for(i = 0; i < count; i++)
		if(flags & table[i].mask) {
			if(s[0])
				strcat(s, ", ");
			if(strlen(s) + strlen(table[i].string) > 77) {
				display(s, 0, 0, pLine);
				s[0] = 0;
			}
			strcat(s, table[i].string);
		}
	if(s[0])
		display(s, 0, 0, pLine);
}
