/**************************************************************************
** Copyright (c) 1996 Novell, Inc.  All Rights Reserved.
**
** THIS WORK IS SUBJECT TO U.S. AND INTERNATIONAL COPYRIGHT LAWS AND
** TREATIES.  USE AND REDISTRIBUTION OF THIS WORK IS SUBJECT TO THE
** LICENSE AGREEMENT ACCOMPANYING THE SOFTWARE DEVELOPMENT KIT (SDK)
** THAT CONTAINS THIS WORK.
** 
** Pursuant to the SDK License Agreement, Novell hereby grants to
** Developer a royalty-free, non-exclusive license to include the
** sample code SAPGENCB.C and derivative binaries in its product.
** Novell grants to Developer worldwide distribution rights to market,
** distribute or sell the sample code SAPGENCB.C and derivative
** binaries as a component of Developer's product(s).  Novell shall
** have no obligations to Developer or Developer's customers with
** respect to this code.
** 
** DISCLAIMER:
** 
** 	Novell, Inc. makes no representations or warranties with respect
** to the contents or use of this code, and specifically disclaims any
** express or implied warranties of merchantability or fitness for any
** particular purpose.  Further, Novell, Inc. reserves the right to revise
** this publication and to make changes to its content, at any time,
** without obligation to notify any person or entity of such revisions or
** changes.
**
** 	Further, Novell, Inc. makes no representations or warranties with
** respect to any software, and specifically disclaims any express or
** implied warranties of merchantability or fitness for any particular
** purpose.  Further, Novell, Inc. reserves the right to make changes to
** any and all parts of the software, at any time, without obligation to
** notify any person or entity of such changes.
**
***************************************************************************
**  File:   STATS.H
**
**  Desc:   Statistics structure and function definitions.
**
**	This is not a complete collection of all possible items that
**	could be used with the server's statistics functions. It may
**	or may not be updated in the future.
**
**  Programmers:
**
**      Ini Who                     Firm
**      -----------------------------------------------------------------------
**      JB  Jan Beulich	            Novell Developer Support.
**
**  History:
**
**      When        Who What
**      -----------------------------------------------------------------------
**      10Jun96     jb  First code.
*/

#ifndef __NWSRV_STATS_H
#define __NWSRV_STATS_H

#define	SS_DEFAULT_BUFFER_SIZE	600

typedef struct SS_PREFIX_TAG {
	LONG	ssServerTime;
	BYTE	ssConsoleVersion;
	BYTE	ssConsoleRevision;
	WORD	ssReserved;
} SS_PREFIX_STRUCT;

typedef struct CPU_INFO_TAG {
	SS_PREFIX_STRUCT cpuPrefix;
	LONG	cpuCount;
	LONG	cpuPageTableOwnerFlag;
	LONG	cpuType;
	LONG	cpuFpuFlag;
	LONG	cpuBusType;
	LONG	cpuIoEngineFlag;
	LONG	cpuFsEngineFlag;
	LONG	cpuNonDedicatedFlag;
	BYTE	cpuStrings[1];
} CPU_INFO_STRUCT;

typedef struct VOLUME_SEGMENT_TAG {
	LONG	vsDevice;
	LONG	vsOffset;
	LONG	vsSize;
} VOLUME_SEGMENT_STRUCT;

typedef struct VOLUME_SEGMENT_LIST_TAG {
	SS_PREFIX_STRUCT vslPrefix;
	LONG	vslSegmentCount;
	VOLUME_SEGMENT_STRUCT vslSegments[1];
} VOLUME_SEGMENT_LIST_STRUCT;

typedef struct LAN_BOARD_LIST_TAG {
	SS_PREFIX_STRUCT lblPrefix;
	LONG	lblMaxCount;
	LONG	lblCount;
	LONG	lblBoardNumber[1];
} LAN_BOARD_LIST_STRUCT;

typedef struct LAN_BOARD_INFO_TAG {
	SS_PREFIX_STRUCT lanPrefix;
	BYTE	lanCfgMajorVer;
	BYTE	lanCfgMinorVer;
	BYTE	lanNodeAddress[6];
	WORD	lanModeFlags;
	WORD	lanBoardNumber;
	WORD	lanBoardInstance;
	LONG	lanMaximumSize;
	LONG	lanMaxRecvSize;
	LONG	lanRecvSize;
	BYTE	*lanCardName;
	BYTE	*lanShortName;
	BYTE	*lanMediaType;
	WORD	lanCardID;
	WORD	lanMediaID;
	WORD	lanTransportTime;
	BYTE	lanReserved[16];
	BYTE	lanMajorVer;
	BYTE	lanMinorVer;
	WORD	lanFlags;
	WORD	lanSendRetries;
	struct LAN_BOARD_INFO_TAG*lanLink;
	WORD	lanSharingFlags;
	WORD	lanSlot;
	struct {
		WORD	portBase;
		WORD	portRange;
	}	lanPort[2];
	struct {
		LONG	memBase;
		WORD	memRange;
	}	lanMemory[2];
	BYTE	lanIntLine[2];
	BYTE	lanDmaLine[2];
	void	*lanResourceTag;
	BYTE	*lanConfig;
	BYTE	*lanCommand;
	BYTE	lanLogicalName[18];
	LONG	lanLinearMemory[2];
	WORD	lanChannel;
	BYTE	lanIoReserved[6];
} LAN_BOARD_INFO_STRUCT;

/* lanModeFlags */
#define MM_REAL_DRIVER_BIT		0x0001
#define MM_DMA_BIT			0x0002
#define MM-DEPENDABLE_BIT		0x0004
#define MM_MULTICAST_BIT		0x0008
#define MM_POINT_TO_POINT_BIT		0x0010
#define MM_PREFILLED_ECB_BIT		0x0020
#define MM_RAW_SENDS_BIT		0x0040
#define MM_DATA_SZ_UNKNOWN_BIT		0x0080
#define MM_SMP_BIT			0x0200
#define MM_FRAG_RECEIVES_BIT		0x0400
#define MM_C_HSM_BIT			0x0800
#define MM_FRAGS_PHYS_BIT		0x1000
#define MM_PROMISCUOUS_BIT		0x2000
#define MM_NONCANONICAL_BIT		0x4000
#define MM_PHYS_NODE_ADDR_BIT		0x8000

/* lanFlags */
#define MF_EISA_BIT			0x0001
#define MF_ISA_BIT			0x0002
#define MF_MCA_BIT			0x0004
#define MF_HUB_MANAGEMENT_BIT		0x0100
#define MF_SOFT_FILT_GRP_BIT		0x0200
#define MF_GRP_ADDR_SUP_BIT		0x0400

LONG	SSGetActiveLANBoardList(LONG, LAN_BOARD_LIST_STRUCT*, LONG);
LONG	SSGetCPUInfo(LONG, CPU_INFO_STRUCT*, LONG);
LONG	SSGetLANConfiguration(LONG, LAN_BOARD_INFO_STRUCT*, LONG);
LONG	SSGetVolumeSegmentList(LONG, VOLUME_SEGMENT_LIST_STRUCT*, LONG);

#endif
