/**************************************************************************
** Copyright (c) 1996 Novell, Inc.  All Rights Reserved.
**
** THIS WORK IS SUBJECT TO U.S. AND INTERNATIONAL COPYRIGHT LAWS AND
** TREATIES.  USE AND REDISTRIBUTION OF THIS WORK IS SUBJECT TO THE
** LICENSE AGREEMENT ACCOMPANYING THE SOFTWARE DEVELOPMENT KIT (SDK)
** THAT CONTAINS THIS WORK.
** 
** Pursuant to the SDK License Agreement, Novell hereby grants to
** Developer a royalty-free, non-exclusive license to include the
** sample code SAPGENCB.C and derivative binaries in its product.
** Novell grants to Developer worldwide distribution rights to market,
** distribute or sell the sample code SAPGENCB.C and derivative
** binaries as a component of Developer's product(s).  Novell shall
** have no obligations to Developer or Developer's customers with
** respect to this code.
** 
** DISCLAIMER:
** 
** 	Novell, Inc. makes no representations or warranties with respect
** to the contents or use of this code, and specifically disclaims any
** express or implied warranties of merchantability or fitness for any
** particular purpose.  Further, Novell, Inc. reserves the right to revise
** this publication and to make changes to its content, at any time,
** without obligation to notify any person or entity of such revisions or
** changes.
**
** 	Further, Novell, Inc. makes no representations or warranties with
** respect to any software, and specifically disclaims any express or
** implied warranties of merchantability or fitness for any particular
** purpose.  Further, Novell, Inc. reserves the right to make changes to
** any and all parts of the software, at any time, without obligation to
** notify any person or entity of such changes.
**
***************************************************************************
**  File:   SYSTEM.C
**
**  Desc:   I/O system specific part of the DAI sample
**
**  Programmers:
**
**      Ini Who                     Firm
**      -----------------------------------------------------------------------
**      JB  Jan Beulich	            Novell Developer Support.
**
**  History:
**
**      When        Who What
**      -----------------------------------------------------------------------
**      10Jun96     jb  First code.
*/

#include <stdio.h>
#include <conio.h>
#include <errno.h>

#include "common.h"

void showSystemInfo(void*__info) {
#define info ((SYSTEM_INFO_STRUCT*)__info)
	unsigned i;
	int hScreen = CreateScreen(info->sysName, POP_UP_SCREEN);
	unsigned line = 0;
	char s[128];

	if(hScreen == EFAILURE) return;
	SetCurrentScreen(hScreen);

	sprintf(s, "Driver Name : %s", info->sysDriverName);
	display(s, 0, 0, &line);

	sprintf(s, "Logical Name : %s", info->sysConfigInfo.ioLogicalName);
	display(s, 0, 0, &line);

	sprintf(s, "Processor Number : %hu", info->sysProcessorNumber);
	display(s, 0, 0, &line);

	sprintf(s, "System Number : %lu", info->sysNumber);
	display(s, 0, 0, &line);

	if(info->sysConfigInfo.ioSlot)
		i = sprintf(s, "Slot %hu ", info->sysConfigInfo.ioSlot);
	else
		i = 0;
	sprintf(s+i, "Sharing Flags = %04hX ", info->sysConfigInfo.ioSharingFlags);
	display(s, 0, 0, &line);

	for(i = 0; i < 2; i++) {
		if(info->sysConfigInfo.ioPort[i].portBase) {
			sprintf(s, "I/O address range %u : %04hX-%04hX",
				i + 1,
				info->sysConfigInfo.ioPort[i].portBase,
				info->sysConfigInfo.ioPort[i].portBase + info->sysConfigInfo.ioPort[i].portRange - 1);
			display(s, 0, 0, &line);
		}

		if(info->sysConfigInfo.ioMemory[i].memBase) {
			sprintf(s, "Memory address range %u : %08lX-%08lX",
				i + 1,
				info->sysConfigInfo.ioMemory[i].memBase,
				info->sysConfigInfo.ioMemory[i].memBase + (info->sysConfigInfo.ioMemory[i].memRange << 4) - 1);
			display(s, 0, 0, &line);
		}

		if(info->sysConfigInfo.ioIntLine[i] != 0xFF) {
			sprintf(s, "Interrupt %u : %u",
				i + 1,
				info->sysConfigInfo.ioIntLine[i]);
			display(s, 0, 0, &line);
		}

		if(info->sysConfigInfo.ioDmaLine[i] != 0xFF) {
			sprintf(s, "DMA channel %u : %u",
				i + 1,
				info->sysConfigInfo.ioDmaLine[i]);
			display(s, 0, 0, &line);
		}
	}

	pressAnyKeyToQuit();
	DestroyScreen(hScreen);
}
