/**************************************************************************
** Copyright (c) 1996 Novell, Inc.  All Rights Reserved.
**
** THIS WORK IS SUBJECT TO U.S. AND INTERNATIONAL COPYRIGHT LAWS AND
** TREATIES.  USE AND REDISTRIBUTION OF THIS WORK IS SUBJECT TO THE
** LICENSE AGREEMENT ACCOMPANYING THE SOFTWARE DEVELOPMENT KIT (SDK)
** THAT CONTAINS THIS WORK.
** 
** Pursuant to the SDK License Agreement, Novell hereby grants to
** Developer a royalty-free, non-exclusive license to include the
** sample code SAPGENCB.C and derivative binaries in its product.
** Novell grants to Developer worldwide distribution rights to market,
** distribute or sell the sample code SAPGENCB.C and derivative
** binaries as a component of Developer's product(s).  Novell shall
** have no obligations to Developer or Developer's customers with
** respect to this code.
** 
** DISCLAIMER:
** 
** 	Novell, Inc. makes no representations or warranties with respect
** to the contents or use of this code, and specifically disclaims any
** express or implied warranties of merchantability or fitness for any
** particular purpose.  Further, Novell, Inc. reserves the right to revise
** this publication and to make changes to its content, at any time,
** without obligation to notify any person or entity of such revisions or
** changes.
**
** 	Further, Novell, Inc. makes no representations or warranties with
** respect to any software, and specifically disclaims any express or
** implied warranties of merchantability or fitness for any particular
** purpose.  Further, Novell, Inc. reserves the right to make changes to
** any and all parts of the software, at any time, without obligation to
** notify any person or entity of such changes.
**
***************************************************************************
**  File:   VOLUME.C
**
**  Desc:   Volume specific part of the DAI sample
**
**  Programmers:
**
**      Ini Who                     Firm
**      -----------------------------------------------------------------------
**      JB  Jan Beulich	            Novell Developer Support.
**
**  History:
**
**      When        Who What
**      -----------------------------------------------------------------------
**      10Jun96     jb  First code.
*/

#include <stdio.h>
#include <string.h>

#include <conio.h>
#include <nwdir.h>
#include <errno.h>

#include "common.h"

void showVolumeInfo(void*__info) {
#define info ((VOLUME_STATS*)__info)
	int hScreen = CreateScreen(info->volumeName, POP_UP_SCREEN);
	unsigned line = 0;
	char s[128];

	if(hScreen == EFAILURE) return;
	SetCurrentScreen(hScreen);

	sprintf(s, "Volume %u, Logical Drive %u, is %smounted and %s",
		info->volumeNumber,
		info->logicalDriveNumber,
		info->isMounted ? "" : "not ",
		info->isRemovable ? "removable" : "fixed");
	display(s, 0, 0, &line);

	sprintf(s, "Blocks: total %hu (%lu Mb), avail %hu (%lu Mb)",
		info->totalBlocks,
		(unsigned long)info->totalBlocks * (unsigned long)info->sectorsPerBlock >> 11,
		info->availableBlocks,
		(unsigned long)info->availableBlocks * (unsigned long)info->sectorsPerBlock >> 11);
	display(s, 0, 0, &line);

	sprintf(s, "Directory slots: total %hu, avail %hu, max used %hu",
		info->totalDirectorySlots,
		info->availableDirectorySlots,
		info->maxDirectorySlotsUsed);
	display(s, 0, 0, &line);

	pressAnyKeyToQuit();
	DestroyScreen(hScreen);
}
